'Date: 14/11/06
'Auteur : ShadowTzu
'Site web: http://shadowtzu.free.fr
'eMail: shadowtzu@wanadoo.fr
'Copyright ShadowTzu tout droits rservs

Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D

Public Class Form1
    Private T3D As Engine    
    Private Inp As Input
    Private objet As Mesh_static
    Private OnRender As Boolean = True

    Private m_fSpeed As Single = 1 / 0.02
    Private sngAngleX As Single
    Private sngAngleY As Single
    Private sngWalk As Single
    Private sngStrafe As Single
    Private Position As Vector3
    Private LookAt As Vector3

    Public TempoA As Single
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If OnRender = True Then
            OnRender = False
            e.Cancel = True
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Show()
        Me.Focus()

        T3D = New Engine(Me.Handle, False)

        objet = New Mesh_static(My.Application.Info.DirectoryPath & "\boite.x")

        Inp = New Input

        Render()
    End Sub

    Private Sub Render()
        Application.DoEvents()
        Dim skycolor As Integer = Get_Color(0.2, 0.2, 0.4, 1)
        Do While OnRender = True
            Input()
            Set_Camera(Position, LookAt)
            'objet.Rotation = New Vector3(objet.Rotation.X, objet.Rotation.Y + 0.01 * T3D.Tempo, objet.Rotation.Z)

            T3D.Render_Clear(skycolor)
            T3D.Render_Begin()
            objet.Render()
            T3D.Render_End()
            TempoA = T3D.Tempo
            Application.DoEvents()
        Loop
        Inp.Dispose()
        T3D.Dispose()
        T3D = Nothing
        Application.Exit()
    End Sub

    Private Sub Input()
        If Inp.Key(DirectInput.Key.Escape) Then OnRender = False
        If Inp.Key(DirectInput.Key.UpArrow) Then sngWalk = 1
        If Inp.Key(DirectInput.Key.DownArrow) Then sngWalk = -1
        If Inp.Key(DirectInput.Key.RightArrow) Then sngStrafe = -1
        If Inp.Key(DirectInput.Key.LeftArrow) Then sngStrafe = 1

        Dim mousex, mousey, mousez As Integer
        Inp.Get_MouseState(mousex, mousey, mousez)
        sngAngleX = sngAngleX - (mousey / 100)
        sngAngleY = sngAngleY - (mousex / 100)

        Dim tempo As Single = T3D.Tempo
        If sngAngleX > 1.3 Then sngAngleX = 1.3
        If sngAngleX < -1.3 Then sngAngleX = -1.3
        Select Case sngWalk
            Case Is > 0
                sngWalk = CSng(sngWalk - 0.01 * tempo)
                If sngWalk < 0 Then sngWalk = 0
            Case Is < 0
                sngWalk = CSng(sngWalk + 0.01 * tempo)
                If sngWalk > 0 Then sngWalk = 0
        End Select

        Select Case sngStrafe
            Case Is > 0
                sngStrafe = CSng(sngStrafe - 0.01 * tempo)
                If sngStrafe < 0 Then sngStrafe = 0
            Case Is < 0
                sngStrafe = CSng(sngStrafe + 0.01 * tempo)
                If sngStrafe > 0 Then sngStrafe = 0
        End Select
        Dim vec As Vector3

        vec.X = CSng(Position.X + (Math.Cos(sngAngleY) * sngWalk / m_fSpeed * tempo) + (Math.Cos(sngAngleY + Math.PI / 2) * sngStrafe / m_fSpeed * tempo))
        vec.Z = CSng(Position.Z + (Math.Sin(sngAngleY) * sngWalk / m_fSpeed * tempo) + (Math.Sin(sngAngleY + Math.PI / 2) * sngStrafe / m_fSpeed * tempo))
        vec.Y = -2.4
        Position = vec

        Dim reg As Vector3
        reg.X = CSng(Position.X + Math.Cos(sngAngleY))
        reg.Y = CSng(Position.Y + Math.Tan(sngAngleX))
        reg.Z = CSng(Position.Z + Math.Sin(sngAngleY))
        LookAt = reg

    End Sub

End Class
